import PFElement from '../../@patternfly/pfelement/dist/pfelement.js';

/*!
 * PatternFly Elements: PfeDocumentation 0.1.1
 * @license
 * Copyright 2020 Red Hat, Inc.
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 * 
*/

// Config for mutation observer to see if things change inside of the component
const lightDomObserverConfig = {
  characterData: true,
  attributes: true,
  subtree: true,
  childList: true
};

class PfeDocumentation extends PFElement {
  static get version() {
    return "0.1.1";
  }

  get html() {
    return `<style>@charset "UTF-8";:host{display:block}:host([hidden]){display:none}/*! normalize.css v3.0.0 | MIT License | git.io/normalize */html{font-family:sans-serif;-ms-text-size-adjust:100%;-webkit-text-size-adjust:100%}body{margin:0}article,aside,details,figcaption,figure,footer,header,hgroup,main,nav,section,summary{display:block}audio,canvas,progress,video{display:inline-block;vertical-align:baseline}audio:not([controls]){display:none;height:0}[hidden],template{display:none}a{background:0 0}a:active,a:hover{outline:0}abbr[title]{border-bottom:1px dotted}b,strong{font-weight:700}dfn{font-style:italic}h1{font-size:2em;margin:.67em 0}mark{background:#ff0;color:#000}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:baseline}sup{top:-.5em}sub{bottom:-.25em}img{border:0}svg:not(:root){overflow:hidden}figure{margin:1em 40px}hr{-webkit-box-sizing:content-box;box-sizing:content-box;height:0}pre{overflow:auto}code,kbd,pre,samp{font-family:monospace,monospace;font-size:1em}button,input,optgroup,select,textarea{color:inherit;font:inherit;margin:0}button{overflow:visible}button,select{text-transform:none}button,html input[type=button],input[type=reset],input[type=submit]{-webkit-appearance:button;cursor:pointer}button[disabled],html input[disabled]{cursor:default}button::-moz-focus-inner,input::-moz-focus-inner{border:0;padding:0}input{line-height:normal}input[type=checkbox],input[type=radio]{-webkit-box-sizing:border-box;box-sizing:border-box;padding:0}input[type=number]::-webkit-inner-spin-button,input[type=number]::-webkit-outer-spin-button{height:auto}input[type=search]{-webkit-appearance:textfield;-webkit-box-sizing:content-box;box-sizing:content-box}input[type=search]::-webkit-search-cancel-button,input[type=search]::-webkit-search-decoration{-webkit-appearance:none}fieldset{border:1px solid silver;margin:0 2px;padding:.35em .625em .75em}legend{border:0;padding:0}textarea{overflow:auto}optgroup{font-weight:700}table{border-collapse:collapse;border-spacing:0}td,th{padding:0}.rhdocs{font-size:16px;line-height:1.5;font-family:RedHatText,Overpass,"Helvetica Neue",Arial,sans-serif;color:#252525;-moz-tab-size:4;-o-tab-size:4;tab-size:4}.rhdocs *,.rhdocs ::after,.rhdocs ::before{-webkit-box-sizing:border-box;box-sizing:border-box}.rhdocs img,.rhdocs object,.rhdocs svg{display:inline-block;vertical-align:middle;max-width:100%}.rhdocs hr{clear:both;margin:1rem 0;height:0;border:0;border-top:1px solid #d2d2d2}.rhdocs a{color:#06c}.rhdocs a:focus,.rhdocs a:hover{color:#036}.rhdocs p{margin:1rem 0}.rhdocs h1,.rhdocs h2,.rhdocs h3,.rhdocs h4,.rhdocs h5,.rhdocs h6{margin:36px 0 18px;font-weight:500}.rhdocs h1,.rhdocs h2,.rhdocs h3{font-family:RedHatDisplay,Overpass,"Helvetica Neue",Arial,sans-serif;line-height:1.4}.rhdocs h1{margin:0;font-size:31.5px;font-weight:400}.rhdocs h2{font-size:27px;font-weight:500}.rhdocs h3{font-size:22px;font-weight:500}.rhdocs h4{font-size:18px;line-height:1.5;font-weight:500}.rhdocs h5{font-size:18px;line-height:1.5;font-weight:700}.rhdocs h6{font-size:18px;line-height:1.5;font-weight:700}.rhdocs .heading{margin:1rem 0 0;font-size:16px;line-height:1.5;text-transform:normal;font-style:normal;font-weight:700;color:#a30000}.rhdocs .heading+.content>:first-child,.rhdocs .heading+p{margin-top:0}.rhdocs ol,.rhdocs ul{margin:1rem 0;padding:0 0 0 1.5rem}.rhdocs ol>li,.rhdocs ul>li{margin:0;padding:0}.rhdocs ol>li>p,.rhdocs ul>li>p{margin:.5rem 0}.rhdocs ol>li>ol,.rhdocs ol>li>ul,.rhdocs ul>li>ol,.rhdocs ul>li>ul{margin:0}.rhdocs dl{margin:1rem 0}.rhdocs dl dt{margin:.5rem 0;font-weight:600}.rhdocs dl dd{margin:.5rem 0 .5rem 1rem}.rhdocs dl dd>p{margin:.5rem 0}.rhdocs table{margin:2rem 0;border:1px solid #d2d2d2;border-collapse:collapse;font-size:16px;line-height:1.5;table-layout:fixed}.rhdocs table caption{margin-top:.5rem;margin-bottom:.5rem;color:#585858;text-align:left}.rhdocs table td,.rhdocs table th{padding:.5em 1rem;border:1px solid #d2d2d2}.rhdocs table td.halign-left,.rhdocs table th.halign-left{text-align:left}.rhdocs table td.halign-center,.rhdocs table th.halign-center{text-align:center}.rhdocs table td.halign-right,.rhdocs table th.halign-right{text-align:right}.rhdocs table td.valign-top,.rhdocs table th.valign-top{vertical-align:top}.rhdocs table td.valign-middle,.rhdocs table th.valign-middle{vertical-align:middle}.rhdocs table td.valign-bottom,.rhdocs table th.valign-bottom{vertical-align:bottom}.rhdocs table thead td,.rhdocs table thead th{background:#f5f5f5;font-weight:600}.rhdocs pre{font-family:Consolas,monospace;white-space:pre-wrap;word-wrap:break-word;word-spacing:normal;word-break:break-all;font-size:14px;line-height:1.5}.rhdocs :not(pre)>code{padding:.25em .5em;font-family:Consolas,monospace;background:#def3ff;color:#004368;font-size:14px;line-height:1.5}.rhdocs{padding:2em}@media (min-width:768px){.has-toc.toc-left .rhdocs{padding:0;display:-ms-grid;display:grid;grid-template-areas:'toc header' 'toc main' 'toc footer';-ms-grid-columns:14rem 2rem auto;grid-template-columns:14rem auto;-ms-grid-rows:auto;grid-template-rows:auto;grid-column-gap:2rem;-webkit-box-align:start;-webkit-align-items:start;-ms-flex-align:start;align-items:start}.has-toc.toc-left .rhdocs .rhdocs-header{padding:2rem 2rem 0 0;grid-area:header;max-width:65em}.has-toc.toc-left .rhdocs .rhdocs-content{padding:0 2rem 0 0;grid-area:main;max-width:65em}.has-toc.toc-left .rhdocs .rhdocs-footer{padding:0 0 2rem;grid-area:footer;max-width:65em}.has-toc.toc-left .rhdocs .rhdocs-toc{grid-area:toc;margin:0}}@media (min-width:768px){.has-toc.toc-left .rhdocs .rhdocs-header{-ms-grid-row:1;-ms-grid-column:3}.has-toc.toc-left .rhdocs .rhdocs-content{-ms-grid-row:2;-ms-grid-column:3}.has-toc.toc-left .rhdocs .rhdocs-footer{-ms-grid-row:3;-ms-grid-column:3}.has-toc.toc-left .rhdocs .rhdocs-toc{-ms-grid-row:1;-ms-grid-row-span:3;-ms-grid-column:1}}@media (min-width:992px){.has-toc.toc-left .rhdocs{-ms-grid-columns:20rem auto;grid-template-columns:20rem auto}}.rhdocs-details{margin:16px 0 48px;padding:0;list-style:none}.rh-docs-details-item{margin:0 0 8px;font-size:16px;line-height:24/16}.rhdocs-products{margin:0 0 16px;font-size:24px;line-height:31/24;font-weight:700;text-transform:uppercase}.rhdocs-product-version{display:block}.rhdocs-author-details{display:inline-block;margin:0;color:#585858}.rhdocs-author-details dd,.rhdocs-author-details dt{margin:0;padding:0;display:inline-block}.rhdocs-author-details dd::before{display:inline-block;content:'('}.rhdocs-author-details dd::after{display:inline-block;content:')'}.rhdocs-revisions{display:inline-block;margin:0;padding:0;list-style:none;color:#585858}.rhdocs-revisions li{display:inline-block}.rhdocs-revisions li:not(:last-child)::after{display:inline-block;content:', '}.rhdocs-author-details+.rhdocs-revisions::before{display:inline-block;margin:0 .125rem;content:'—'}.rhdocs-revnumber{text-transform:capitalize}.rhdocs-toc{margin:1rem 0 2rem;padding:1rem;background:#f2f2f2}.rhdocs-toc>:last-child{margin-bottom:0}.rhdocs-toc .rhdocs-toctitle{margin-top:0;font-size:20px;text-transform:none;line-height:1.5;font-weight:600}.rhdocs-toc ol{padding-left:0;counter-reset:item}.rhdocs-toc ol li{display:table;margin:.5rem 0}.rhdocs-toc ol li::before{display:table-cell;padding-right:.25rem;content:counters(item, ".") ".";counter-increment:item}.preamble{margin:2rem 0;font-size:20px;line-height:1.5}.preamble .admonitionblock,.preamble .sidebarblock{font-size:1rem}.sect1{margin:2rem 0 1rem}.admonitionblock{margin:2rem 0;padding:1rem;border:1px solid #d2d2d2;border-left:4px solid #252525}.admonitionblock.has-icon{display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;-webkit-box-flex:1;-webkit-flex:1 1 auto;-ms-flex:1 1 auto;flex:1 1 auto;-webkit-box-align:start;-webkit-align-items:flex-start;-ms-flex-align:start;align-items:flex-start}.admonitionblock.has-icon .icon{margin-right:1rem;font-size:1.5rem}.admonitionblock.note{color:#004368;border-left-color:#39a5dc}.admonitionblock.caution{color:#763d04;border-left-color:#ec7a08}.admonitionblock.warning{color:#795600;border-left-color:#f0ab00}.admonitionblock.important{color:#470000;border-left-color:#a30000}.admonitionblock .content>:first-child{margin-top:0}.admonitionblock .content>:last-child{margin-bottom:0}.colist ol{margin:1rem 0 2rem;padding:0;list-style:none}.colist ol li{margin:.5rem 0;padding-left:2rem}.colist ol li .colist-num{float:left;margin-left:-2rem}.colist-num{-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none}.conum{position:relative;top:-.125em;display:inline-block;padding:0;background:#c00;color:#fff;border-radius:50%;font-family:RedHatText,Overpass,"Helvetica Neue",Arial,sans-serif;font-size:.75rem;font-weight:600;font-style:normal;text-align:center;width:1.25rem;height:1.25rem;line-height:1.35rem;vertical-align:middle}.listingblock,.literalblock{margin:1rem 0}.listingblock pre,.literalblock pre{padding:1rem;background:#252525;color:#fff;font-family:Consolas,monospace;font-size:14px;line-height:1.5}.quoteblock,.verseblock{margin:1rem 0;padding:1rem 1rem 1rem 2rem;border-left:4px solid #d2d2d2}.quoteblock>:first-child,.verseblock>:first-child{margin-top:0}.quoteblock .content,.verseblock .content{font-family:RedHatText,Overpass,"Helvetica Neue",Arial,sans-serif;font-size:20px;line-height:1.5}.quoteblock .attribution,.verseblock .attribution{font-size:14px;line-height:1.5;font-style:italic;text-transform:uppercase;font-weight:600}.quoteblock .attribution .citetitle,.verseblock .attribution .citetitle{color:#585858}.quoteblock .attribution cite,.verseblock .attribution cite{font-size:1em}.quoteblock.pullleft,.verseblock.pullleft{float:left;margin-right:3rem;width:25rem}@media (min-width:768px){.quoteblock.pullleft,.verseblock.pullleft{margin-left:-1rem}}.quoteblock.pullright,.verseblock.pullright{float:right;margin-left:3rem;width:25rem}@media (min-width:768){.quoteblock.pullright,.verseblock.pullright{margin-right:-2rem}}@media (min-width:992px){.quoteblock.pullright,.verseblock.pullright{margin-right:-10rem}}.quoteblock blockquote{margin:0;padding:0;font-style:italic}.quoteblock blockquote .content>:first-child{margin-top:0}.quoteblock blockquote .content>:first-child::before{display:block;margin-right:.5rem;float:left;content:'“';color:#e00;font-size:2.75rem;font-style:normal;line-height:1.125em}.imageblock{margin:1rem 0}.imageblock .caption{display:block;margin:.5rem 0 0;font-size:14px;line-height:1.5;color:#585858}.imageblock.pullleft{float:left;margin-right:3rem;width:25rem}@media (min-width:768px){.imageblock.pullleft{margin-left:-1rem}}.imageblock.pullright{float:right;margin-left:3rem;width:25rem}@media (min-width:768){.imageblock.pullright{margin-right:-2rem}}@media (min-width:992px){.imageblock.pullright{margin-right:-10rem}}.imageblock.interrupter{margin:2rem 0}@media (min-width:768px){.imageblock.interrupter{margin-right:-2rem;margin-left:-1rem}.imageblock.interrupter .caption{margin-right:2rem;margin-left:1rem}}@media (min-width:992px){.imageblock.interrupter{margin-right:-10rem}.imageblock.interrupter .caption{margin-right:10rem}}.imageblock.interrupter img{max-width:100%}.rhdocs-footnotes{margin:3rem 0 1rem;padding:1rem 0 0;border-top:1px solid #d2d2d2}.rhdocs-footnotes>ol{margin:0;padding:0 0 0 1.5rem}@supports (counter-reset:footnotenum){.rhdocs-footnotes>ol{padding:0;list-style:none;counter-reset:footnotenum}.rhdocs-footnotes>ol>li{counter-increment:footnotenum}.rhdocs-footnotes>ol>li::before{display:inline-block;content:"[" counter(footnotenum) "]";margin-right:.25rem;color:#585858}}.rhdocs-footer{margin:3rem 0 0;padding:1rem;background:#ededed;color:#252525;font-size:14px;line-height:1.5}.center{margin-left:auto;margin-right:auto}.stretch{width:100%}.visually-hidden{position:absolute;width:1px;height:1px;padding:0;margin:-1px;overflow:hidden;clip:rect(0,0,0,0);border:0}code[class*=language-],pre[class*=language-]{text-align:left;white-space:pre-wrap;word-wrap:break-word;word-spacing:normal;word-break:break-all;-moz-tab-size:4;-o-tab-size:4;tab-size:4;-webkit-hyphens:none;-ms-hyphens:none;hyphens:none}pre[class*=language-]{padding:1em;margin:.5em 0;overflow:auto}:not(pre)>code[class*=language-],pre[class*=language-]{background:#252525}:not(pre)>code[class*=language-]{padding:.1em;border-radius:.3em;white-space:normal}.token.block-comment,.token.cdata,.token.comment,.token.doctype,.token.prolog{color:#999}.token.punctuation{color:#ccc}.token.attr-name,.token.deleted,.token.namespace,.token.tag{color:#e2777a}.token.function-name{color:#6196cc}.token.boolean,.token.function,.token.number{color:#f08d49}.token.class-name,.token.constant,.token.property,.token.symbol{color:#f8c555}.token.atrule,.token.builtin,.token.important,.token.keyword,.token.selector{color:#cc99cd}.token.attr-value,.token.char,.token.regex,.token.string,.token.variable{color:#7ec699}.token.entity,.token.operator,.token.url{color:#67cdcc}.token.bold,.token.important{font-weight:700}.token.italic{font-style:italic}.token.entity{cursor:help}.token.inserted{color:green}.icon.fa{cursor:default}a .icon{cursor:inherit}.admonitionblock .icon[class^='fa icon-']{font-size:2.5em;cursor:default}.admonitionblock .icon.icon-note:before{content:'\f05a';color:#39a5dc}.admonitionblock .icon.icon-tip:before{content:'\f0eb'}.admonitionblock .icon.icon-warning:before{content:'\f071';color:#f0ab00}.admonitionblock .icon.icon-caution:before{content:'\f071';color:#ec7a08}.admonitionblock .icon.icon-important:before{content:'\f06a';color:#a30000}.listingblock pre code,.literalblock pre code{color:inherit;text-shadow:none;white-space:inherit!important;line-height:inherit;font-family:inherit}
/*# sourceMappingURL=cp-documentation.min.css.map */
</style><div id="wrapper"></div>`;
  }

  static get properties() {
    return {"loaded":{"title":"Loaded","type":"string","enum":[],"default":"","prefixed":true}," endpoint":{"title":" endpoint","type":"string","enum":[],"default":"","prefixed":true}," css":{"title":" css","type":"string","enum":[],"default":"","prefixed":true}};
  }

  static get slots() {
    return {"default":{"title":"Default slot","type":"array","namedSlot":false,"items":{"oneOf":[{"$ref":"raw"}]}}};
  }
  static get tag() {
    return "cp-documentation";
  }

  get schemaUrl() {
    return "cp-documentation.json";
  }

  get templateUrl() {
    return "cp-documentation.html";
  }

  get styleUrl() {
    return "cp-documentation.scss";
  }

  static get events() {
    return {
      change: `${this.tag}:change`,
      loaded: `${this.tag}:loaded`
    };
  }

  // Declare the type of this component
  static get PfeType() {
    return PFElement.PfeTypes.Container;
  }

  static get observedAttributes() {
    return ["pfe-loaded", "pfe-endpoint", "pfe-css"];
  }

  constructor() {
    super(PfeDocumentation, { type: PfeDocumentation.PfeType });

    // Ensure 'this' is tied to the component object in these member functions
    this._processLightDom = this._processLightDom.bind(this);
    this._loadCss = this._loadCss.bind(this);
    this.loadData = this.loadData.bind(this);
    this.getData = this.getData.bind(this);

    // Setup mutation observer to watch for content changes
    this._observer = new MutationObserver(this._processLightDom);

    // Initialize object to store data in
    this._moduleData = {};
  }

  connectedCallback() {
    super.connectedCallback();

    this._processLightDom();

    this._observer.observe(this, lightDomObserverConfig);

    this.addEventListener(PfeDocumentation.events.change, this._changeHandler);
    this.addEventListener(PfeDocumentation.events.loaded, this._loadedHandler);

    if (this.hasAttribute("pfe-css")) {
      this._loadCss();
    }
  }

  disconnectedCallback() {
    this.removeEventListener(
      PfeDocumentation.events.change,
      this._changeHandler
    );
    this.removeEventListener(
      PfeDocumentation.events.loaded,
      this._loadedHandler
    );
  }

  attributeChangedCallback(attr, oldVal, newVal) {
    super.attributeChangedCallback(attr, oldVal, newVal);

    switch (attr) {
      case "pfe-endpoint":
        this.loadData();
        break;
    }
  }

  /**
   * Handle initialization or changes in light DOM
   * Clone them into the shadowRoot
   */
  _processLightDom() {
    // Preventing issues in IE11 & Edge
    if (window.ShadyCSS) {
      this._observer.disconnect();
    }

    const shadowWrapper = this.shadowRoot.getElementById("wrapper"),
      oldContentWrapper = this.shadowRoot.getElementById("content"),
      // An element that light dom content will be put into and replaces the shadowWrapper at the end
      newContentWrapper = document.createElement("div");

    this.childNodes.forEach(childNode => {
      const cloneNode = childNode.cloneNode(true);
      newContentWrapper.append(cloneNode);
    });

    if (oldContentWrapper) {
      shadowWrapper.replaceChild(newContentWrapper, oldContentWrapper);
    } else {
      shadowWrapper.append(newContentWrapper);
    }
    newContentWrapper.setAttribute("id", "content");

    // Reconnecting mutationObserver for IE11 & Edge
    if (window.ShadyCSS) {
      this._observer.observe(this, lightDomObserverConfig);
    }
  }

  _loadCss() {
    // If we have an attribute and the CSS hasn't been loaded yet
    if (
      this.hasAttribute("pfe-css") &&
      !this.shadowRoot.getElementById("pfe-css")
    ) {
      const pfeCssUrl = this.getAttribute("pfe-css");
      const linkTag = document.createElement("link");
      linkTag.setAttribute("id", "pfe-css");
      linkTag.setAttribute("href", pfeCssUrl);
      linkTag.setAttribute("rel", "stylesheet");
      this.shadowRoot.append(linkTag);
    }
  }

  /**
   * Get the content from pfe-endpoint attribute
   *
   * Also loads the body content
   */
  loadData() {
    const endpointUrl = this.getAttribute("pfe-endpoint");
    // @todo local caching?
    if (endpointUrl) {
      fetch(endpointUrl)
        .then(response => response.json())
        .then(data => {
          if (typeof data.module === "object") {
            this.setAttribute("pfe-loaded", "");
            this._moduleData = data.module;
            if (this._moduleData.body) {
              this.innerHTML = this._moduleData.body;
            }
          }
        })
        .catch(error => console.log(`${this.tag}: ${error}`));
    }
  }

  /**
   * Allows parent DOM to access the module data
   * @return {object} The module data
   */
  getData() {
    if (Object.keys(this._moduleData).length) {
      return this._moduleData;
    }

    return null;
  }

  _changeHandler(event) {
    this.emitEvent(PfeDocumentation.events.change, {
      detail: {}
    });
  }

  _loadedHandler(event) {
    this.emitEvent(PfeDocumentation.events.loaded, {
      detail: {}
    });
  }
}

PFElement.create(PfeDocumentation);

export default PfeDocumentation;
//# sourceMappingURL=cp-documentation.js.map
